﻿Imports Infragistics.Shared
Imports Infragistics.Win
Imports Infragistics.Win.UltraWinGrid
Imports Estimation.BusinessLayer

Public Class clsUltraGridSummaryCalculator
    Implements ICustomSummaryCalculator

    Private Quantity As Decimal = 0
    Private totals As Decimal = 0
    Private UnitCost As Decimal = 0
    Private UnitPrice As Decimal = 0
    Private strUnit As String = ""

    Public Sub New()
    End Sub

    Private Sub BeginCustomSummary(ByVal summarySettings As SummarySettings, ByVal rows As RowsCollection) Implements ICustomSummaryCalculator.BeginCustomSummary

        ' Begins the summary for the SummarySettings object passed in. Implementation of 
        ' this method should reset any state variables used for calculating the summary.
        Me.totals = 0
        Me.UnitCost = 0
        Me.UnitPrice = 0
        Me.Quantity = 0
        Me.strUnit = ""
    End Sub

    Private Sub AggregateCustomSummary(ByVal summarySettings As SummarySettings, ByVal row As UltraGridRow) Implements ICustomSummaryCalculator.AggregateCustomSummary

        ' Here is where we process each row that gets passed in.

        Dim AssemblyID As Object = row.GetCellValue(summarySettings.SourceColumn.Band.Columns("AssemblyID"))
        Dim BidID As Object = row.GetCellValue(summarySettings.SourceColumn.Band.Columns("BidID"))
        Dim BidDetailID As Object = row.GetCellValue(summarySettings.SourceColumn.Band.Columns("BidDetailID"))
        Dim FormulaID As Object = row.GetCellValue(summarySettings.SourceColumn.Band.Columns("FormulaID"))
        Dim unit As Object = row.GetCellValue(summarySettings.SourceColumn.Band.Columns("Unit"))
        Dim quantity As Object = row.GetCellValue(summarySettings.SourceColumn.Band.Columns("Quantity"))
        Dim iUnitCost As Object = row.GetCellValue(summarySettings.SourceColumn.Band.Columns("TotalCost"))
        Dim iUnitPrice As Object = row.GetCellValue(summarySettings.SourceColumn.Band.Columns("TotalPrice"))

        If AssemblyID IsNot DBNull.Value Then
            strUnit = "LS"
        Else
            strUnit = ""
        End If
        ' Handle null values
        If unit Is DBNull.Value Or quantity Is DBNull.Value Then
            Return
        End If

        Try
            Me.UnitCost = Me.UnitCost + IIf(iUnitCost Is DBNull.Value, 0, iUnitCost)
            Me.UnitPrice = Me.UnitPrice + IIf(iUnitPrice Is DBNull.Value, 0, iUnitPrice)
           If unit.ToString.Trim = strUnit And Me.Quantity = 0 Then
                Me.Quantity = quantity
                Return
            End If
        Catch e As Exception
            ' This should not happen if the columns are numeric.
            Debug.Assert(False, "Exception thrown while trying to convert cell's value to decimal !")
        End Try

    End Sub

    Private Function EndCustomSummary(ByVal summarySettings As SummarySettings, ByVal rows As RowsCollection) Implements ICustomSummaryCalculator.EndCustomSummary

        ' This gets called when the every row has been processed so here is where we
        ' would return the calculated summary value.
        If summarySettings.Key = "Quantity" Then
            Return IIf(Me.Quantity = 0, DBNull.Value, Me.Quantity)
        ElseIf summarySettings.Key.ToUpper = "UNIT" Then
            Return Me.strUnit
        ElseIf summarySettings.Key.ToUpper = "UNITPRICE" Then
            Return IIf((Me.UnitPrice / IIf(Me.Quantity = 0, 1, Me.Quantity)) = 0, DBNull.Value, (Me.UnitPrice / IIf(Me.Quantity = 0, 1, Me.Quantity)))
        ElseIf summarySettings.Key.ToUpper = "UNITCOST" Then
            Return IIf((Me.UnitCost / IIf(Me.Quantity = 0, 1, Me.Quantity)) = 0, DBNull.Value, (Me.UnitCost / IIf(Me.Quantity = 0, 1, Me.Quantity)))
        End If
    End Function
End Class
