﻿Imports Infragistics.Win.UltraWinGrid
Imports Infragistics.Win

Public Class Form1

    Dim ds As New DataSet
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim strPath As String = Application.StartupPath
        strPath = strPath & "\sampleData.xml"
        Try
            ds.ReadXml(strPath)
            If ds.Tables.Count > 0 Then
                ulGridEstimateDetail.DataSource = ds.Tables(0)
                SetBidDetailGridLayout()
            End If
        Catch
            MessageBox.Show("Error Loading Data")
        End Try
    End Sub

    Private Sub chbGroup_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chbGroup.CheckedChanged
        ulGridEstimateDetail.DisplayLayout.Bands(0).SortedColumns.Remove(ulGridEstimateDetail.DisplayLayout.Bands(0).Columns("ASSEMBLYGROUPNAME"))
        If chbGroup.Checked Then
            ulGridEstimateDetail.DisplayLayout.Bands(0).SortedColumns.Add(ulGridEstimateDetail.DisplayLayout.Bands(0).Columns("ASSEMBLYGROUPNAME"), False, True)
        Else
            ulGridEstimateDetail.DisplayLayout.Bands(0).SortedColumns.Add(ulGridEstimateDetail.DisplayLayout.Bands(0).Columns("RowNo"), False, False)
        End If
        ulGridEstimateDetail.Rows.ExpandAll(True)
        SummaryCalculator(chbGroup.Checked)
    End Sub

    Private Sub SummaryCalculator(ByVal boolGroup As Boolean)
        Try
            Dim formatString As String
            Dim DecimalsPlaces As String
            Dim band As UltraGridBand = Me.ulGridEstimateDetail.DisplayLayout.Bands(0)
            band.Summaries.Clear()

            If boolGroup Then
                Dim summary As SummarySettings = band.Summaries.Add("Quantity", SummaryType.Custom, _
                    New clsUltraGridSummaryCalculator(), band.Columns("Quantity"), SummaryPosition.UseSummaryPositionColumn, Nothing)
                summary.SummaryDisplayArea = SummaryDisplayAreas.InGroupByRows
                formatString = "0.00"
                If formatString <> "0" Then
                    DecimalsPlaces = formatString.Split(".")(1)
                Else
                    DecimalsPlaces = ""
                End If
                summary.DisplayFormat = "{0:##,##,##0." & DecimalsPlaces & "}"

                formatString = "0.00"
                If formatString <> "0" Then
                    DecimalsPlaces = formatString.Split(".")(1)
                Else
                    DecimalsPlaces = ""
                End If
                summary = band.Summaries.Add("UnitPrice", SummaryType.Custom, _
                    New clsUltraGridSummaryCalculator(), band.Columns("UnitPrice"), SummaryPosition.UseSummaryPositionColumn, Nothing)
                summary.SummaryDisplayArea = SummaryDisplayAreas.InGroupByRows
                summary.DisplayFormat = "{0:##,##,##0." & DecimalsPlaces & "}"

                summary = band.Summaries.Add("UnitCost", SummaryType.Custom, _
                    New clsUltraGridSummaryCalculator(), band.Columns("UnitCost"), SummaryPosition.UseSummaryPositionColumn, Nothing)
                summary.SummaryDisplayArea = SummaryDisplayAreas.InGroupByRows
                summary.DisplayFormat = "{0:##,##,##0." & DecimalsPlaces & "}"

                summary = band.Summaries.Add("UNIT", SummaryType.Custom, _
                    New clsUltraGridSummaryCalculator(), band.Columns("Unit"), SummaryPosition.UseSummaryPositionColumn, Nothing)
                summary.SummaryDisplayArea = SummaryDisplayAreas.InGroupByRows
                summary.DisplayFormat = "{0:n2}"
                'summary.Band.Override.CellAppearance.TextHAlign = HAlign.Right
                'ulGridEstimateDetail.DisplayLayout.Override.GroupBySummaryValueAppearance.TextHAlign = HAlign.Left
                ulGridEstimateDetail.DisplayLayout.Bands(0).Columns("UNIT").GroupByRowAppearance.TextHAlign = HAlign.Left
                summary.Appearance.TextHAlign = HAlign.Left
                'summary.SummaryPosition = SummaryPosition.Left
            End If


        Catch
            MessageBox.Show("Unable to calculate summary for headers.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub SetBidDetailGridLayout()

        ulGridEstimateDetail.DisplayLayout.Override.HeaderPlacement = HeaderPlacement.FixedOnTop
        ulGridEstimateDetail.DisplayLayout.Override.ActiveCellAppearance.BackColor = Color.FromArgb(0, 196, 234, 245)
        With ulGridEstimateDetail.DisplayLayout.Bands(0)
            Try
                If Not ulGridEstimateDetail.DisplayLayout.Bands(0).Columns.Exists("Tag") Then
                    Dim ulcolSelect As UltraGridColumn
                    ulcolSelect = .Columns.Add("Tag", "")
                    ulcolSelect.DataType = GetType(Boolean)
                    ulcolSelect.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.CheckBox
                    ulcolSelect.Width = 5

                    ulcolSelect.LockedWidth = True
                    .Columns("Tag").Header.VisiblePosition = 0
                    .Columns("Tag").CellActivation = Activation.AllowEdit
                    .Columns("Tag").Header.Caption = "Tag"
                    .Columns("Tag").Header.Tag = "Tag"
                End If

            Catch ex As Exception

            End Try
            If ulGridEstimateDetail.DisplayLayout.Bands(0).Columns.Exists("BidPriceMarkupID") Then
                .Columns("BidPriceMarkupID").Hidden = True
            End If

            With .Columns("BidDayCost")
                .Hidden = True
            End With
            With .Columns("IsVisible")
                .Hidden = True
                .Header.Tag = "IsVisible"
            End With
            With .Columns("Tag")
                .Hidden = True
            End With
            With .Columns("Selected")
                .Hidden = True
                .Header.Tag = "Selected"
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
            End With

            With .Columns("IsBidDayCost")
                .Header.Tag = "IsBidDayCost"
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Hidden = True
            End With

            With .Columns("IsAlternateSelected")
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Hidden = True
                .Header.Tag = "IsAlternateSelected"
            End With


            With .Columns("FormulaDetailID")
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Hidden = True
                .Header.Tag = "FormulaDetailID"
            End With

            With .Columns("FormulaID")
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Hidden = True
                .Header.Tag = "FormulaID"
            End With
            With .Columns("AssemblygroupID")
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Hidden = True
                .Header.Tag = "AssemblygroupID"
            End With

            With .Columns("IsComplete")
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Hidden = True
                .Header.Tag = "IsComplete"
            End With
            'ulGridEstimateDetail.CreationFilter = aCheckBoxOnHeader_CreationFilter
            'ulGridEstimateDetail.DisplayLayout.Bands(0).Columns("Tag").Header.Fixed = True

            With .Columns("ItemCode")
                .Hidden = True
                .Header.Tag = "ItemCode"
                .Header.Caption = "Item Code"
                .Header.Appearance.TextHAlign = HAlign.Right
                .CellAppearance.TextHAlign = HAlign.Right
                .CellActivation = Activation.NoEdit
            End With

            'With .Columns("Markup")
            '    .Hidden = True
            '    .Header.Tag = "Markup"
            'End With

            With .Columns("Notes")
                .Hidden = True
                .Header.Tag = "Notes"
                .Header.Appearance.TextHAlign = HAlign.Left
                .CellAppearance.TextHAlign = HAlign.Left
            End With

            With .Columns("Misc1")
                .Hidden = True
                .Header.Tag = "Misc1"
                .Header.Caption = "Miscellaneous 1"
                .Header.Appearance.TextHAlign = HAlign.Left
                .CellAppearance.TextHAlign = HAlign.Left
            End With

            With .Columns("Misc2")
                .Hidden = True
                .Header.Tag = "Misc2"
                .Header.Caption = "Miscellaneous 2"
                .Header.Appearance.TextHAlign = HAlign.Left
                .CellAppearance.TextHAlign = HAlign.Left
            End With

            With .Columns("Misc3")
                .Hidden = True
                .Header.Tag = "Misc3"
                .Header.Appearance.TextHAlign = HAlign.Left
                .Header.Caption = "Miscellaneous 3"
                .CellAppearance.TextHAlign = HAlign.Left
            End With
            With .Columns("Misc4")
                .Hidden = True
                .Header.Tag = "Misc4"
                .Header.Appearance.TextHAlign = HAlign.Left
                .CellAppearance.TextHAlign = HAlign.Left
                .Header.Caption = "Miscellaneous 4"
            End With
            With .Columns("AlternateID")
                .Hidden = True
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Header.Tag = "AlternateID"
            End With

            With .Columns("AssemblyGroupName")
                .Hidden = True
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Header.Tag = "AssemblyGroupName"
            End With


            With .Columns("AlternateID_Alternate")
                .Header.Tag = "AlternateID_Alternate"
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Hidden = True
            End With


            With .Columns("Alternate")
                .Hidden = True
                .Header.Tag = "Alternate"
                .Header.Appearance.TextHAlign = HAlign.Left
                .CellAppearance.TextHAlign = HAlign.Left
                .CellActivation = Activation.NoEdit
            End With

            'With .Columns("Size")
            '    .Hidden = True
            '    .Header.Tag = "Size"
            '    .NullText = ""
            '    .Header.Appearance.TextHAlign = HAlign.Right
            '    .CellAppearance.TextHAlign = HAlign.Right
            '    .Format = "##,##,###"
            'End With

            With .Columns("UPC")
                .Hidden = True
                .Header.Tag = "UPC"
                .Header.Appearance.TextHAlign = HAlign.Left
            End With

            With .Columns("Weight")
                .Hidden = True
                .Header.Tag = "Weight"
                .NullText = ""
                .Header.Appearance.TextHAlign = HAlign.Right
                .CellAppearance.TextHAlign = HAlign.Right
                .Format = "##,##,###"
            End With

            With .Columns("TakeoffDate")
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Hidden = True
                .Header.Tag = "TakeoffDate"
                .Header.Caption = "Takeoff Date"
                .Header.Appearance.TextHAlign = HAlign.Left
                .Style = UltraWinGrid.ColumnStyle.Date

                Dim dateformat As String = "dd/MM/yy"
                dateformat = dateformat.Replace("yy", "yyyy")
                .Format = dateformat

                System.Threading.Thread.CurrentThread.CurrentCulture = System.Threading.Thread.CurrentThread.CurrentCulture.Clone()
                System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.ShortDatePattern = dateformat
            End With

            ''Vinay03022012 ========================
            If .Columns.Exists("ItemDate") = True Then
                With .Columns("ItemDate")
                    .Hidden = True
                    .Header.Tag = "ItemDate"
                    .Header.Caption = "Date" 'Vinay12062012 changed from "Item Date" to "Date"
                    .Header.Appearance.TextHAlign = HAlign.Left
                    .CellAppearance.TextHAlign = HAlign.Left
                    .CellActivation = Activation.NoEdit
                    'Vinay19042012===
                    .Style = UltraWinGrid.ColumnStyle.Date
                    Dim dateformat As String = "dd/MM/yy"
                    dateformat = dateformat.Replace("yy", "yyyy")
                    .Format = dateformat

                    System.Threading.Thread.CurrentThread.CurrentCulture = System.Threading.Thread.CurrentThread.CurrentCulture.Clone()
                    System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.ShortDatePattern = dateformat
                    '================
                End With
            End If
            ''======================================


            ''Vinay03022012 ========================
            If .Columns.Exists("LaborConversionLevel") = True Then
                With .Columns("LaborConversionLevel")
                    .Hidden = True
                    .Header.Tag = "LaborConversionLevel"
                    .Header.Caption = "Labor ConversionLevel"
                    .Header.Appearance.TextHAlign = HAlign.Left
                    .CellAppearance.TextHAlign = HAlign.Left
                    .CellActivation = Activation.NoEdit
                End With
            End If
            ''======================================

            ''Vinay03022012 ========================
            If .Columns.Exists("Vendor") = True Then
                With .Columns("Vendor")
                    .Hidden = True
                    .Header.Tag = "Vendor"
                    .Header.Caption = "Vendor"
                    .Header.Appearance.TextHAlign = HAlign.Left
                    .CellAppearance.TextHAlign = HAlign.Left
                    .CellActivation = Activation.NoEdit
                    .CellAppearance.BackColor = Color.FromArgb(255, 255, 200)
                End With
            End If
            If .Columns.Exists("PartNumber") = True Then
                With .Columns("PartNumber")
                    .Hidden = True
                    .Header.Tag = "PartNumber"
                    .Header.Caption = "Part Number"
                    .Header.Appearance.TextHAlign = HAlign.Left
                    .CellAppearance.TextHAlign = HAlign.Left
                    .CellActivation = Activation.NoEdit
                    .CellAppearance.BackColor = Color.FromArgb(255, 255, 200)
                End With
            End If
            ''======================================

            With .Columns("Formula")
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Hidden = True
                .Header.Tag = "Formula"
                .CellAppearance.TextHAlign = HAlign.Left
                .Header.Appearance.TextHAlign = HAlign.Left
                .CellActivation = Activation.NoEdit
            End With

            'With .Columns("CrewID")
            '    .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
            '    .Hidden = True
            '    .Header.Tag = "CrewID"
            'End With

            'With .Columns("Crew")
            '    .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
            '    .Hidden = True
            '    .Header.Tag = "Crew"
            '    .Header.Caption = "Crew"
            '    .CellActivation = Activation.NoEdit 'Vinay14032012
            '    .Header.Appearance.TextHAlign = HAlign.Left
            '    .CellAppearance.TextHAlign = HAlign.Left
            '    .CellActivation = Activation.NoEdit
            'End With


            'With .Columns("SubContractorID")
            '    .Hidden = False
            '    .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
            '    .Header.Tag = "SubContractorID"
            '    .Header.Caption = "SubContractor"
            '    '.ValueList = cmbSubContractor
            '    .Header.Appearance.TextHAlign = HAlign.Left
            '    .CellAppearance.TextHAlign = HAlign.Left
            'End With

            With .Columns("DivisionID")
                .Hidden = True
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Header.Tag = "DivisionID"
            End With

            'With .Columns("DivisionCode")
            '    .Hidden = True
            '    .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
            '    .Header.Tag = "DivisionCode"
            'End With
            With .Columns("SubContractorName")
                .Hidden = True
                .Header.Caption = "SubContractor"
                .Header.Tag = "SubContractorName"
                .Header.Appearance.TextHAlign = HAlign.Left
                .CellAppearance.TextHAlign = HAlign.Left
                '.ValueList = cmbSubContractor
            End With

            With .Columns("RowNo")
                .Hidden = False
                .CellActivation = Activation.NoEdit
                .Header.Caption = "Code"
                .Width = 50
                .Header.Tag = "RowNo"
            End With

            With .Columns("BidDetailID")
                .Hidden = True
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Header.Tag = "BidDetailID"
            End With

            With .Columns("BidID")
                .Hidden = True
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Header.Tag = "BidID"
            End With

            With .Columns("ItemID")
                .Hidden = True
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Header.Tag = "ItemID"
            End With

            With .Columns("Description")
                .Hidden = False
                .Width = 300
                .NullText = ""
                .Header.Tag = "Description"
                .Header.Appearance.TextHAlign = HAlign.Left
                .CellAppearance.TextHAlign = HAlign.Left
            End With

            'With .Columns("Manufacturer")
            '    .Hidden = False
            '    .NullText = ""
            '    .Header.Tag = "Manufacturer"
            '    .Header.Appearance.TextHAlign = HAlign.Left
            '    .CellAppearance.TextHAlign = HAlign.Left
            'End With

            With .Columns("Labor Cost Link")
                .Hidden = False
                .NullText = ""
                .Header.Tag = "Labor Cost Link"
                .Header.Appearance.TextHAlign = HAlign.Left
                .CellAppearance.TextHAlign = HAlign.Left
            End With

            With .Columns("QuotedItem")
                .Hidden = True
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Header.Tag = "QuotedItem"
                .Header.Caption = "Quoted Item"
                .Style = UltraWinGrid.ColumnStyle.CheckBox

            End With

            With .Columns("Division")
                .Hidden = True
                .CellActivation = Activation.NoEdit
                ' .CellAppearance.BackColor = Color.FromArgb(248, 248, 248)
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Header.Tag = "Division"
                .Header.Appearance.TextHAlign = HAlign.Left
                .CellAppearance.TextHAlign = HAlign.Left
            End With

            With .Columns("SubDivision")
                .Hidden = True
                .Header.Caption = "Sub Division"
                .CellActivation = Activation.NoEdit
                '  .CellAppearance.BackColor = Color.FromArgb(248, 248, 248)
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Header.Tag = "SubDivision"
                .Header.Appearance.TextHAlign = HAlign.Left
                .CellAppearance.TextHAlign = HAlign.Left
            End With

            With .Columns("SubDivisionID")
                .Hidden = True
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Header.Tag = "SubDivisionID"
            End With

            'With .Columns("SubDivisionCode")
            '    .Hidden = True
            '    .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
            '    .Header.Tag = "SubDivisionCode"
            'End With

            With .Columns("Assembly")
                .Hidden = True
                .CellActivation = Activation.NoEdit
                '.CellAppearance.BackColor = Color.FromArgb(248, 248, 248)
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Header.Tag = "Assembly"
                .Header.Appearance.TextHAlign = HAlign.Left
                .CellAppearance.TextHAlign = HAlign.Left
            End With

            With .Columns("AssemblyID")
                .Hidden = True
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Header.Tag = "AssemblyID"
            End With

            With .Columns("Quantity")
                .Hidden = False
                .CellAppearance.TextHAlign = HAlign.Right
                .Header.Appearance.TextHAlign = HAlign.Right

                Dim formatString As String = "0.00"

                Dim DecimalsPlaces As String
                If formatString <> "0" Then
                    DecimalsPlaces = formatString.Split(".")(1)
                Else
                    DecimalsPlaces = ""
                End If

                .Format = "##,##,##0." & DecimalsPlaces & ";-##,##,##0." & DecimalsPlaces & ";##,##,###.##;"

                .NullText = ""
                .Header.Tag = "Quantity"
            End With

            With .Columns("Unit")
                .Hidden = False
                '.ValueList = cmbUnitList
                .Width = 40
                .Format = ""
                .Header.Tag = "Unit"
                .Header.Appearance.TextHAlign = HAlign.Left
                .CellAppearance.TextHAlign = HAlign.Left
                .CellActivation = Activation.AllowEdit
                .Style = UltraWinGrid.ColumnStyle.DropDownList
            End With

            'With .Columns("Markup")
            '    .Hidden = True
            '    .CellAppearance.TextHAlign = HAlign.Right
            '    .Header.Appearance.TextHAlign = HAlign.Right
            '    '.Format = "0.00"
            '    Dim formatString As String = "#,0.00"

            '    Dim DecimalsPlaces As String
            '    If formatString <> "0" Then
            '        DecimalsPlaces = formatString.Split(".")(1)
            '    Else
            '        DecimalsPlaces = ""
            '    End If

            '    .Format = "##,##,##0." & DecimalsPlaces & ";-##,##,##0." & DecimalsPlaces & ";##,##,###.##;" '"#,0"
            '    .NullText = ""
            '    .Header.Appearance.TextHAlign = HAlign.Right
            '    .CellAppearance.TextHAlign = HAlign.Right
            '    .Header.Tag = "Markup"
            'End With












            If .Columns.Contains("BidPriceMarkupID") = True Then
                With .Columns("BidPriceMarkupID")
                    .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                    .Hidden = True
                    .Header.Tag = "BidPriceMarkupID"
                End With
            End If

            With .Columns("SubDivisionRpt")
                .ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                .Hidden = True
                .Header.Tag = "SubDivisionRpt"
            End With

            With .Columns("CostMarkup")
                .Hidden = True
                .CellActivation = Activation.NoEdit
                .CellAppearance.BackColor = Color.FromArgb(255, 255, 200)
                .Header.Appearance.TextHAlign = HAlign.Right
                .CellAppearance.TextHAlign = HAlign.Right
                '.Format = "0.00"
                Dim formatString As String = "#,0.00"

                Dim DecimalsPlaces As String
                If formatString <> "0" Then
                    DecimalsPlaces = formatString.Split(".")(1)
                Else
                    DecimalsPlaces = ""
                End If

                .Format = "##,##,##0." & DecimalsPlaces & ";-##,##,##0." & DecimalsPlaces & ";##,##,###.##;" '"#,0"
                .NullText = ""
                .Header.Tag = "CostMarkup"
                .Header.Caption = "Cost Markup"
            End With


            With .Columns("PriceMarkup")
                .Hidden = True
                .CellActivation = Activation.NoEdit
                .CellAppearance.BackColor = Color.FromArgb(255, 255, 200)
                .Header.Appearance.TextHAlign = HAlign.Right
                .CellActivation = Activation.NoEdit
                .CellAppearance.TextHAlign = HAlign.Right
                '.Format = "0.00"
                Dim formatString As String = "#,0.00"

                Dim DecimalsPlaces As String
                If formatString <> "0" Then
                    DecimalsPlaces = formatString.Split(".")(1)
                Else
                    DecimalsPlaces = ""
                End If

                .Format = "##,##,##0." & DecimalsPlaces & ";-##,##,##0." & DecimalsPlaces & ";##,##,###.##;" '"#,0"
                .NullText = ""
                .Header.Tag = "PriceMarkup"
                .Header.Caption = "Price Markup"
            End With


            'With .Columns("ItemMarkup")
            '    .Hidden = True
            '    .CellActivation = Activation.NoEdit
            '    .CellAppearance.BackColor = Color.FromArgb(255, 255, 200)
            '    .Header.Appearance.TextHAlign = HAlign.Right
            '    .CellAppearance.TextHAlign = HAlign.Right
            '    '.Format = "0.00"
            '    Dim formatString As String = "#,0.00"

            '    Dim DecimalsPlaces As String
            '    If formatString <> "0" Then
            '        DecimalsPlaces = formatString.Split(".")(1)
            '    Else
            '        DecimalsPlaces = ""
            '    End If

            '    .Format = "##,##,##0." & DecimalsPlaces & ";-##,##,##0." & DecimalsPlaces & ";##,##,###.##;" '"#,0"
            '    .NullText = ""
            '    .Header.Tag = "ItemMarkup"
            '    .Header.Caption = "Item Markup"
            'End With

            With .Columns("TotalPrice")
                .Hidden = True
                .CellActivation = Activation.NoEdit
                .Header.Caption = "Total Price"
                '.CellAppearance.BackColor = Color.LightGray
                .CellAppearance.BackColor = Color.FromArgb(255, 255, 200)
                .CellAppearance.TextHAlign = HAlign.Right
                .Header.Appearance.TextHAlign = HAlign.Right

                'Dim formatString As String = Estimation.BusinessLayer.GetFormatString(Estimation.BusinessLayer.GlobalRegistry.DecimalPlacesForTotals, "0")
                'formatString = formatString.PadRight(Estimation.BusinessLayer.GlobalRegistry.DecimalPlacesForTotals + 2, "0")

                Dim formatString As String = "0"
                Dim DecimalsPlaces As String
                If formatString <> "0" Then
                    DecimalsPlaces = formatString.Split(".")(1)
                Else
                    DecimalsPlaces = ""
                End If

                .Format = "##,##,##0." & DecimalsPlaces & ";-##,##,##0." & DecimalsPlaces & ";##,##,###.##;" 'formatString
                .NullText = "" ' "0"
                .Header.Tag = "TotalPrice"
            End With

            With .Columns("TotalCost")
                .Hidden = False
                .Header.Caption = "Total Cost"
                .CellActivation = Activation.NoEdit
                '.CellAppearance.BackColor = Color.LightGray
                .CellAppearance.BackColor = Color.FromArgb(255, 255, 200)
                .CellAppearance.TextHAlign = HAlign.Right
                .Header.Appearance.TextHAlign = HAlign.Right

                'Dim formatString As String = Estimation.BusinessLayer.GetFormatString(Estimation.BusinessLayer.GlobalRegistry.DecimalPlacesForTotals, "0")
                ' formatString = formatString.PadRight(Estimation.BusinessLayer.GlobalRegistry.DecimalPlacesForTotals + 2, "0")

                Dim formatString As String = "0"

                Dim DecimalsPlaces As String
                If formatString <> "0" Then
                    DecimalsPlaces = formatString.Split(".")(1)
                Else
                    DecimalsPlaces = ""
                End If

                .Format = "##,##,##0." & DecimalsPlaces & ";-##,##,##0." & DecimalsPlaces  ' if any tym u want to convert 0 to blank append '& ";##,##,###.##;"'  
                .NullText = "0." & DecimalsPlaces
                .Header.Tag = "TotalCost"
            End With

            With .Columns("UnitCost")
                .Header.Caption = "Unit Cost"
                .Hidden = True
                .CellActivation = Activation.NoEdit
                '.CellAppearance.BackColor = Color.LightGray
                .CellAppearance.BackColor = Color.FromArgb(255, 255, 200)
                .Header.Appearance.TextHAlign = HAlign.Right
                .CellAppearance.TextHAlign = HAlign.Right
                'Dim formatString As String = Estimation.BusinessLayer.GetFormatString(Estimation.BusinessLayer.GlobalRegistry.DecimalPlacesForCosts, "0.00")
                'formatString = formatString.PadRight(Estimation.BusinessLayer.GlobalRegistry.DecimalPlacesForCosts + 2, "0")

                Dim formatString As String = "0.00"

                Dim DecimalsPlaces As String
                If formatString <> "0" Then
                    DecimalsPlaces = formatString.Split(".")(1)
                Else
                    DecimalsPlaces = ""
                End If

                .Format = "##,##,##0." & DecimalsPlaces & ";-##,##,##0." & DecimalsPlaces & ";##,##,###.##;" 'formatString
                .NullText = ""
                .Header.Tag = "UnitCost"
            End With

            With .Columns("UnitPrice")
                .Header.Caption = "Unit Price"
                .Hidden = True
                .CellActivation = Activation.NoEdit
                '.CellAppearance.BackColor = Color.LightGray
                .CellAppearance.BackColor = Color.FromArgb(255, 255, 200)
                .Header.Appearance.TextHAlign = HAlign.Right
                .CellAppearance.TextHAlign = HAlign.Right
                'Dim formatString As String = Estimation.BusinessLayer.GetFormatString(Estimation.BusinessLayer.GlobalRegistry.DecimalPlacesForCosts, "0.00")

                Dim formatString As String = "0.00"

                Dim DecimalsPlaces As String
                If formatString <> "0" Then
                    DecimalsPlaces = formatString.Split(".")(1)
                Else
                    DecimalsPlaces = ""
                End If

                .Format = "##,##,##0." & DecimalsPlaces & ";-##,##,##0." & DecimalsPlaces & ";##,##,###.##;" 'formatString
                .NullText = ""
                .Header.Tag = "UnitPrice"
            End With
            'ulGridEstimateDetail.CreationFilter = aCheckBoxOnHeader_CreationFilter_detail
        End With
        'Me.ulGridEstimateDetail.DisplayLayout.AutoFitStyle = UltraWinGrid.AutoFitStyle.ExtendLastColumn

        If ulGridEstimateDetail.DisplayLayout.Bands(0).Summaries.Count > 0 Then
            Dim formatString1 As String = "0:$ ##,##0.00#"
            If formatString1 = "0" Then
                ulGridEstimateDetail.DisplayLayout.Bands(0).Summaries(0).DisplayFormat = "{0:$ 0} "
                If ulGridEstimateDetail.DisplayLayout.Bands(0).Summaries.Count > 1 Then
                    ulGridEstimateDetail.DisplayLayout.Bands(0).Summaries(1).DisplayFormat = "{0:$ 0} "
                End If
            Else
                ulGridEstimateDetail.DisplayLayout.Bands(0).Summaries(0).DisplayFormat = "{" & formatString1 & "}"
                If ulGridEstimateDetail.DisplayLayout.Bands(0).Summaries.Count > 1 Then
                    ulGridEstimateDetail.DisplayLayout.Bands(0).Summaries(1).DisplayFormat = "{" & formatString1 & "}"
                End If
            End If
        End If


    End Sub

    Private Sub ulGridEstimateDetail_InitializeGroupByRow(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeGroupByRowEventArgs) Handles ulGridEstimateDetail.InitializeGroupByRow
        If e.Row.Column.Key.ToUpper = "ASSEMBLYGROUPNAME" Then
            If e.Row.Value IsNot DBNull.Value AndAlso e.Row.Value.ToString.Contains("|") Then
                e.Row.Description = IIf(e.Row.Value.ToString.Split("|")(0).ToString.Trim = "#", e.Row.Value.ToString.Split("|")(1).ToString.Trim, e.Row.Value.ToString.Split("|")(0).ToString.Trim)
            End If
        End If
    End Sub

    Private Sub ulGridEstimateDetail_InitializeLayout(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles ulGridEstimateDetail.InitializeLayout
        Me.ulGridEstimateDetail.DisplayLayout.Override.GroupByRowDescriptionMask = "[Value]"

        Me.ulGridEstimateDetail.DisplayLayout.Override.ActiveRowAppearance.BackColor = Infragistics.Win.Office2007ColorTable.Colors.RibbonTabAreaBackColorGradientLight
        Me.ulGridEstimateDetail.DisplayLayout.Override.ActiveRowAppearance.ForeColor = Color.Black
        ulGridEstimateDetail.DisplayLayout.Override.GroupBySummaryDisplayStyle = GroupBySummaryDisplayStyle.SummaryCells
        ulGridEstimateDetail.DisplayLayout.Override.GroupBySummaryValueAppearance.TextHAlign = HAlign.Right
    End Sub
End Class
